"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var path = require('path');

var fs = require('fs-extra');

var Obj2fsHOC = function Obj2fsHOC(WrappedObject) {
  return /*#__PURE__*/function (_WrappedObject) {
    _inherits(_class, _WrappedObject);

    var _super = _createSuper(_class);

    function _class() {
      _classCallCheck(this, _class);

      return _super.apply(this, arguments);
    }

    _createClass(_class, [{
      key: "setKey",
      // constructor() {
      //   super()
      // }
      // must call this function to attach object to store by key
      value: function setKey(key) {
        this.key = key;
        return this;
      }
      /* returns JSON String representation of the object */

    }, {
      key: "stringify",
      value: function stringify() {
        return JSON.stringify(this);
      }
      /* returns Object instance of a current class */

    }, {
      key: "parse",
      value: function parse(json) {
        var obj = JSON.parse(json);
        return Object.assign(this, obj);
      }
      /* store object in fs, key === file_name */

    }, {
      key: "store",
      value: function store() {
        var key = this.key;
        delete this.key; // key is transitent property, let's clear it before persisting to fs

        var string = this.stringify();
        fs.outputFileSync(path.resolve(key), string);
        this.key = key;
        return string;
      }
      /* retrieve object from fs, key === file_name */

    }, {
      key: "retrieve",
      value: function retrieve() {
        if (!fs.existsSync(path.resolve(this.key))) {
          throw new Error('No such key or file name found on disk');
        }

        return this.parse(fs.readFileSync(path.resolve(this.key)));
      }
      /*  retrieve object from fs, key === file_name, or return new Object initialized with default constructor() */

    }, {
      key: "retrieveOrNew",
      value: function retrieveOrNew() {
        if (!fs.existsSync(path.resolve(this.key))) {
          this.store();
        }

        return this.parse(fs.readFileSync(path.resolve(this.key)));
      }
    }]);

    return _class;
  }(WrappedObject);
};

var _default = Obj2fsHOC;
exports["default"] = _default;